Exclude RPMs and output xml files from framework packing
[csit.git] / bootstrap-vpp-verify-semiweekly.sh
index e7be38c..070dca2 100644 (file)
@@ -21,42 +21,66 @@ RETURN_STATUS=0
 cat /etc/hostname
 cat /etc/hosts
 
-export DEBIAN_FRONTEND=noninteractive
-sudo apt-get -y update
-sudo apt-get -y install libpython2.7-dev python-virtualenv
-
 PYBOT_ARGS="--noncritical MULTI_THREAD"
 
-ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
+ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
 
 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
 export PYTHONPATH=${SCRIPT_DIR}
 
+# Create tmp dir
+mkdir ${SCRIPT_DIR}/tmp
+
+# Use tmp dir to store log files
+LOG_PATH="${SCRIPT_DIR}/tmp"
+
+if [ -f "/etc/redhat-release" ]; then
+    DISTRO="CENTOS"
+    sudo yum install -y python-devel python-virtualenv
+else
+    DISTRO="UBUNTU"
+    export DEBIAN_FRONTEND=noninteractive
+    sudo apt-get -y update
+    sudo apt-get -y install libpython2.7-dev python-virtualenv
+fi
 
 # 1st step: Download and prepare VPP packages
 
 # Temporarily download VPP packages from nexus.fd.io
-rm -f *.deb
 if [ "${#}" -ne "0" ]; then
     arr=(${@})
     echo ${arr[0]}
 else
-    # Download the latest VPP build .deb install packages
+    case "$DISTRO" in
+        CENTOS )
+            PACKAGE=rpm
+            ;;
+        UBUNTU )
+            PACKAGE=deb
+    esac
+    # Download the latest VPP build install packages
+    rm -f *.${PACKAGE}
     echo Downloading VPP packages...
-    bash ${SCRIPT_DIR}/resources/tools/download_install_vpp_pkgs.sh --skip-install
+    bash ${SCRIPT_DIR}/resources/tools/scripts/download_install_vpp_pkgs.sh --skip-install
 fi
 
-VPP_DEBS=(*.deb)
-echo ${VPP_DEBS[@]}
+# Take vpp package and get the vpp version
+VPP_PKGS=(*.$PACKAGE)
+case "$DISTRO" in
+        CENTOS )
+            VPP_VER="$( expr match $(ls *.rpm | head -n 1) 'vpp-\(.*\).rpm' )"
+            ;;
+        UBUNTU )
+            VPP_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
+esac
 
-VPP_VER=$(echo ${VPP_DEBS#vpp-})
-VPP_VER=$(echo ${VPP_VER%.deb})
-echo VPP version to be tested: ${VPP_VER}
+echo ${VPP_PKGS[@]}
 
 set +x
-echo "******************************************************************************"
-echo "1st step: Download VPP packages                                       FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "1st step: Download VPP packages                                                                                                 FINISHED"
+echo "VPP version to be tested: ${VPP_VER}"
+echo "****************************************************************************************************************************************"
 set -x
 
 
@@ -70,9 +94,9 @@ echo Installing requirements...
 pip install -r ${SCRIPT_DIR}/requirements.txt
 
 set +x
-echo "******************************************************************************"
-echo "2nd step: Start virtual env and install requirements                  FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "2nd step: Start virtual env and install requirements                                                                            FINISHED"
+echo "****************************************************************************************************************************************"
 set -x
 
 
@@ -86,6 +110,17 @@ VIRL_USERNAME=jenkins-in
 VIRL_PKEY=priv_key
 VIRL_SERVER_STATUS_FILE="status"
 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
+VIRL_SESSION_EXPIRY="620"
+
+case "$DISTRO" in
+        CENTOS )
+            VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_CENTOS)
+            VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_CENTOS)
+            ;;
+        UBUNTU )
+            VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_UBUNTU)
+            VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_UBUNTU)
+esac
 
 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
 
@@ -163,18 +198,18 @@ done
 
 
 VIRL_DIR_LOC="/tmp"
-VPP_DEBS_VIRL=(${VPP_DEBS[@]})
+VPP_PKGS_VIRL=(${VPP_PKGS[@]})
 
 # Prepend directory location at remote host to deb file list
-for index in "${!VPP_DEBS_VIRL[@]}"; do
-    VPP_DEBS_VIRL[${index}]=${VIRL_DIR_LOC}/${VPP_DEBS_VIRL[${index}]}
+for index in "${!VPP_PKGS_VIRL[@]}"; do
+    VPP_PKGS_VIRL[${index}]=${VIRL_DIR_LOC}/${VPP_PKGS_VIRL[${index}]}
 done
 
-echo "Updated file names: " ${VPP_DEBS_VIRL[@]}
+echo "Updated file names: " ${VPP_PKGS_VIRL[@]}
 
 cat ${VIRL_PKEY}
 # Copy the files to VIRL host
-scp ${SSH_OPTIONS} *.deb \
+scp ${SSH_OPTIONS} *.${PACKAGE} \
     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
 
 result=$?
@@ -194,9 +229,11 @@ function stop_virl_simulation {
 
 VIRL_SID=$(ssh ${SSH_OPTIONS} \
     ${VIRL_USERNAME}@${VIRL_SERVER} \
-    "start-testcase -c double-ring-nested ${VPP_DEBS_VIRL[@]}")
+    "start-testcase -vv --copy ${VIRL_TOPOLOGY} \
+    --expiry ${VIRL_SESSION_EXPIRY} \
+    --release ${VIRL_RELEASE} ${VPP_PKGS_VIRL[@]}")
 retval=$?
-if [ "$?" -ne "0" ]; then
+if [ ${retval} -ne "0" ]; then
     echo "VIRL simulation start failed"
     exit ${retval}
 fi
@@ -218,15 +255,15 @@ scp ${SSH_OPTIONS} \
     topologies/enabled/topology_VIRL.yaml
 
 retval=$?
-if [ "$?" -ne "0" ]; then
+if [ ${retval} -ne "0" ]; then
     echo "Failed to copy topology file from VIRL simulation"
     exit ${retval}
 fi
 
 set +x
-echo "******************************************************************************"
-echo "3rd step: Start the simulation on the VIRL server                     FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "3rd step: Start the simulation on the VIRL server                                                                               FINISHED"
+echo "****************************************************************************************************************************************"
 set -x
 
 
@@ -239,22 +276,24 @@ echo Running functional tests on the VIRL system...
 
 # There are used three iterations of functional tests there
 # to check the stability and reliability of the results.
+partial_logs=""
 for test_set in 1 2 3
 do
     echo
     echo Functional test loop: ${test_set}
     echo
 
-    pybot -L TRACE \
+    pybot -L TRACE -W 136\
         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
-        --suite "tests.func" \
+        --suite "tests.vpp.func" \
         --include vm_envAND3_node_single_link_topo \
         --include vm_envAND3_node_double_link_topo \
         --exclude PERFTEST \
         --noncritical EXPECTED_FAILING \
-        --output log_func_test_set${test_set} \
+        --output ${LOG_PATH}/output_func_test_set${test_set} \
         tests/
     PARTIAL_RC=$(echo $?)
+    partial_logs="${partial_logs} ${LOG_PATH}/output_func_test_set${test_set}.xml"
     if [ ${PARTIAL_RC} -eq 250 ]; then
         MORE_FAILS=1
     fi
@@ -262,103 +301,11 @@ do
 done
 
 set +x
-echo "******************************************************************************"
-echo "4th step: Run functional tests                                        FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "4th step: Run functional tests                                                                                                  FINISHED"
+echo "****************************************************************************************************************************************"
 set -x
 
-
-# 5th step: Reserve and prepare HW system
-
-echo Making a reservation for the HW system...
-
-# Space separated list of available testbeds, described by topology files
-TOPOLOGIES="topologies/available/lf_testbed1.yaml \
-            topologies/available/lf_testbed2.yaml \
-            topologies/available/lf_testbed3.yaml"
-
-# Reservation dir
-RESERVATION_DIR="/tmp/reservation_dir"
-INSTALLATION_DIR="/tmp/install_dir"
-
-WORKING_TOPOLOGY=""
-
-# We iterate over available topologies and wait until we reserve topology
-while :; do
-    for TOPOLOGY in ${TOPOLOGIES};
-    do
-        python ${SCRIPT_DIR}/resources/tools/topo_reservation.py -t ${TOPOLOGY}
-        if [ $? -eq 0 ]; then
-            WORKING_TOPOLOGY=${TOPOLOGY}
-            echo "Reserved: ${WORKING_TOPOLOGY}"
-            break
-        fi
-    done
-
-    if [ ! -z "${WORKING_TOPOLOGY}" ]; then
-        # Exit the infinite while loop if we made a reservation
-        break
-    fi
-
-    # Wait ~3minutes before next try
-    SLEEP_TIME=$[ ( $RANDOM % 20 ) + 180 ]s
-    echo "Sleeping ${SLEEP_TIME}"
-    sleep ${SLEEP_TIME}
-done
-
-function cancel_all {
-    python ${SCRIPT_DIR}/resources/tools/topo_installation.py -c -d ${INSTALLATION_DIR} -t $1
-    python ${SCRIPT_DIR}/resources/tools/topo_reservation.py -c -t $1
-}
-
-# Upon script exit, cleanup the VIRL simulation execution
-# and cancel the reservation and installation of HW system
-# and delete all vpp packages.
-trap "stop_virl_simulation; cancel_all ${WORKING_TOPOLOGY}" EXIT
-
-python ${SCRIPT_DIR}/resources/tools/topo_installation.py -t ${WORKING_TOPOLOGY} \
-                                                       -d ${INSTALLATION_DIR} \
-                                                       -p ${VPP_DEBS[@]}
-
-if [ $? -eq 0 ]; then
-    echo "VPP Installed on hosts from: ${WORKING_TOPOLOGY}"
-else
-    echo "Failed to copy vpp deb files to DUTs"
-    exit 1
-fi
-
-set +x
-echo "******************************************************************************"
-echo "5th step: Making a reservation for HW system                          FINISHED"
-echo "******************************************************************************"
-set -x
-
-# 6th step: Run performance tests
-
-# Performance tests on HW system
-echo Performance tests on HW system
-
-pybot ${PYBOT_ARGS} \
-    -L TRACE \
-    -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-    --suite "tests.perf" \
-    --include perftest_long \
-    --output log_perf_test_set \
-    tests/
-
-PARTIAL_RC=$(echo $?)
-if [ ${PARTIAL_RC} -eq 250 ]; then
-    MORE_FAILS=1
-fi
-RC=$((RC+PARTIAL_RC))
-
-set +x
-echo "******************************************************************************"
-echo "6th step: Run performance tests                                       FINISHED"
-echo "******************************************************************************"
-set -x
-
-
 # Set RETURN_STATUS=1 if some critical test failed
 if [ ! ${RC} -eq 0 ]; then
         RETURN_STATUS=1
@@ -368,10 +315,10 @@ fi
 if [ ${RC} -eq 0 ]; then
     set +x
     echo
-    echo "=============================================================================="
-    echo "Final result of all test loops:                                       | PASS |"
+    echo "========================================================================================================================================"
+    echo "Final result of all test loops:                                                                                                 | PASS |"
     echo "All critical tests have passed."
-    echo "=============================================================================="
+    echo "========================================================================================================================================"
     echo
     set -x
 elif [ ${MORE_FAILS} -eq 0 ]; then
@@ -382,45 +329,32 @@ elif [ ${MORE_FAILS} -eq 0 ]; then
     fi
     set +x
     echo
-    echo "=============================================================================="
-    echo "Final result of all test loops:                                       | FAIL |"
+    echo "========================================================================================================================================"
+    echo "Final result of all test loops:                                                                                                 | FAIL |"
     echo "${RC} critical ${HLP_STR} failed."
-    echo "=============================================================================="
+    echo "========================================================================================================================================"
     echo
     set -x
 else
     set +x
     echo
-    echo "=============================================================================="
-    echo "Final result of all test loops:                                       | FAIL |"
+    echo "========================================================================================================================================"
+    echo "Final result of all test loops:                                                                                                 | FAIL |"
     echo "More then 250 critical tests have failed in one test loop."
-    echo "=============================================================================="
+    echo "========================================================================================================================================"
     echo
     set -x
 fi
 
-
 # 7th step: Post-processing test data
 echo Post-processing test data...
 
-# Getting JSON perf data output
-python ${SCRIPT_DIR}/resources/tools/robot_output_parser.py \
-       -i ${SCRIPT_DIR}/log_perf_test_set.xml \
-       -o ${SCRIPT_DIR}/output_perf_data.xml \
-       -v ${VPP_VER}
-if [ ! $? -eq 0 ]; then
-    echo "Parsing ${SCRIPT_DIR}/log_perf_test_set.xml failed"
-fi
-
 # Rebot output post-processing
 rebot --noncritical EXPECTED_FAILING \
-      --output output.xml \
-      ./log_func_test_set1.xml ./log_func_test_set2.xml \
-      ./log_func_test_set3.xml ./log_perf_test_set.xml
+      --output output.xml ${partial_logs}
 
 # Remove unnecessary files
-rm -f ./log_test_set1.xml ./log_test_set2.xml ./log_test_set3.xml \
-    ./log_perf_test_set.xml
+rm -f ${partial_logs}
 
 # Archive artifacts
 mkdir archive